#
# Common definitions for RPC libraries & examples
#
# G. Vanem <giva@bgnett.no> Apr. 1998
#

#
# Waterloo tcp/ip root-directory. Change to suite.
# It is assumed $(WATT_ROOT) is set in environment.
#
WATT_INC = $(WATT_ROOT)\inc
WATT_LIB = $(WATT_ROOT)\lib

#
# Our root for RPC directories. Change to suite
#
RPC_ROOT = $(WATT_ROOT)\rpc

#
# RPC generator program
#
RPC_GEN    = $(RPC_ROOT)\rpcgen\rpcgen.exe
RPC_GEN_DJ = $(subst \,/,$(RPC_ROOT))/rpcgen/rpcgen.exe

#
# Definitions for CFLAGS.
# Remove RPC_SECURE for non-DES version
#
RPC_DEFS = -DDEBUG -DRPC_SECURE

#
# All library sources are here (though only used in .\src\makefile.*)
#
LIB_SRC = authunip.c auth_des.c auth_non.c auth_uni.c bindresv.c cache.c    \
          clnt_gen.c clnt_per.c clnt_raw.c clnt_sim.c clnt_tcp.c clnt_udp.c \
          des_cryp.c des_soft.c get_myad.c key_call.c key_prot.c netname.c  \
          openchil.c pmap_cln.c pmap_get.c pmap_gp.c  pmap_p2.c  pmap_pro.c \
          pmap_rmt.c pub_key.c  pmap_svc.c rpc_cmnd.c rpc_cmsg.c rpc_dtsz.c \
          rpc_prot.c rpc_enc.c  rtime.c    svc.c      svc_auth.c svc_des.c  \
          svc_raw.c  svc_run.c  svc_simp.c svc_tcp.c  svc_udp.c  unixuid.c  \
          xcrypt.c   xdr.c      xdr_arry.c xdr_floa.c xdr_mem.c  xdr_rec.c  \
          xdr_ref.c  xdr_stio.c getrpc.c   config.c   xdryp.c    yperr_st.c \
          yplib.c    ypprot_e.c yp_all.c   yp_first.c yp_mapli.c yp_maste.c \
          yp_match.c yp_order.c

#
# Borland specifics
#
BC_MAKE   = maker.exe
BC_RPCLIB = $(RPC_ROOT)\lib\rpc_bcc.lib
BC_CC     = bcc.exe
BC_CFLAGS = -ml -O2 -v -I$(WATT_INC) $(RPC_DEFS)
BC_LFLAGS = -ml -ls -v -L $(BC_RPCLIB)

#
# GCC/djgpp specifics
#
DJ_MAKE   = $(DJDIR)/bin/make.exe
DJ_DESTDIR= $(DJDIR)/bin
DJ_RPCLIB = $(subst \,/,$(RPC_ROOT))/lib/librpc.a
DJ_CC     = gcc.exe
DJ_CFLAGS = -g -O2 -Wall -I$(subst \,/,$(WATT_INC)) $(RPC_DEFS)
DJ_LFLAGS = $(subst \,/,$(RPC_ROOT))/lib/librpc.a \
            $(subst \,/,$(WATT_ROOT))/lib/libwatt.a

#
# Metaware HighC specifics
#
HC_MAKE   = maker.exe
HC_RPCLIB = $(RPC_ROOT)\lib\rpc_hx.lib
HC_CC     = hc386.exe
HC_CFLAGS = -w2 -g -586 -O3 -I$(WATT_INC) $(RPC_DEFS)   \
            -Hpragma=offwarn(572) -Hpragma=offwarn(679) \
            -Hsuffix=.o32 -Hnocopyr -Hnoswap            \
            -Hon=Recognize_library -Hon=char_is_rep     \
            -Hon=quiet -Hpragma=stack_size_warn(13000)

