/*
 * dir_proc.c: remote readdir implementation
 */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <errno.h>
#include <direct.h>
#include <dirent.h>
#include <rpc/rpc.h>
#include <sys/dir.h>
#include "dir.h"

readdir_res *readdir_1 (nametype *dirname)
{
  DIR           *dirp;
  struct dirent *d;
  namelist  nl;
  namelist *nlp;
  static    readdir_res res;  /* must be static! */
  
  /*
   * Open directory
   */
  dirp = opendir (*dirname);
  if (dirp == NULL)
  {
    res.errno = errno;
    return (&res);
  }

  /*
   * Free previous result
   */
  xdr_free (xdr_readdir_res, (char*)&res);

  /*
   * Collect directory entries
   */
  nlp = &res.readdir_res_u.list;
  while ((d = readdir(dirp)) != NULL)
  {
    nl = *nlp = malloc (sizeof(namenode));
    nl->name  = strdup (d->d_name);
    nlp = &nl->next;
  }
  *nlp = NULL;

  /*
   * Return the result
   */
  res.errno = 0;
  closedir (dirp);
  return (&res);
}
