/*
 * $NetBSD: extern.h,v 1.1 1997/10/25 13:45:55 lukem Exp $
 */
#ifndef __PCNFSD_EXTERN_H
#define __PCNFSD_EXTERN_H

#include <pwd.h>
#include "paths.h"

#define zchar   0x5b
#define NOBODY  (uid_t)(-2)
#define NUMUIDS 64

/*
 * cache.c
 */
void add_cache_entry (struct passwd *);
int  check_cache (char *, char *, int *, int *);

/*
 * pcnfs_v2.c
 */
void free_mapreq_results (mapreq_res);
void fillin_extra_groups (char *, u_int, int *, u_int[]);

/*
 * print.c
 */
extern  char     sp_name[MAXPATHLEN];
extern  pr_list  printers;
extern  pr_queue queue;

void    mon_printers (void);
int     build_pr_list (void);
pirstat build_pr_queue (printername, username, int, int *, int *);
psrstat pr_start (void);
psrstat pr_start2 (char *, char *, char *, char *, char *, char **);
void    run_ps630 (char *, char *);
pcrstat pr_cancel (char *, char *, char *);
pirstat pr_init (char *, char *, char **);
pirstat get_pr_status (printername, bool_t*, bool_t*, int*, bool_t*, char*);
void    free_pr_list_item (pr_list);
void    free_pr_queue_item (pr_queue);
void    add_printer_alias (char *, char *, char *);
pr_list list_virtual_printers (void);
char   *map_printer_name (char *printer);
char   *expand_alias (char *printer, char *file, char *user, char *host);

/*
 * misc.c
 */
extern int interrupted;

void *grab (int);
char *my_strdup (char *s);
int   suspicious (char *s);
void  scramble (char *s1, char *s2);

char *mapfont (char f, char i, char b);
void  run_ps630 (char *f, char *opts);
FILE *su_popen (char *user, char *cmd, int maxtime);
int   su_pclose (FILE *ptr);
void  config_from_file (void);
int   strembedded (char *, char *);
struct passwd *get_password (char *usrnam, char **msgpp);


#ifdef USE_YP
char *find_entry (char *, char *);
#endif

#ifdef USE_GETUSERSHELL
char *getusershell();
#endif

extern char *crypt();

extern void outsnl (const char *msg); /* libwatt.a, strings.c */
#define msg_out(msg) outsnl(msg)

#endif /* __PCNFSD_EXTERN_H */

