/* @(#)rpc_util.h    2.1 88/08/01 4.0 RPCSRC */
/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/* @(#)rpc_util.h 1.6 87/06/24 (C) 1987 SMI */

/*
 * rpc_util.h, Useful definitions for the RPC protocol compiler 
 * Copyright (C) 1987, Sun Microsystems, Inc. 
 */

#ifndef __RPC_UTIL_H
#define __RPC_UTIL_H

#include <stdlib.h>
#include <malloc.h>

#ifdef __GNUC__
#include <unistd.h>
#endif

extern void *_malloc        (size_t size, char *file, int line);
#define malloc(x)           _malloc (x, __FILE__, __LINE__)
#define ARGSUSED(x)         (x = x)
#define streq(a,b)          (strcmp(a,b) == 0)

#define VERBOSE(str)        if (cmd.verbose) fprintf (stderr, str)
#define VERBOSE1(fmt,a)     if (cmd.verbose) fprintf (stderr, fmt, a)
#define VERBOSE2(fmt,a,b)   if (cmd.verbose) fprintf (stderr, fmt, a, b)

#define WRITE_MODE  "wt"
#define READ_MODE   "rt"

#ifdef USE_LONG_FOR_INT32
#  define INT32_NAM  "u_long"
#  define INT32_PTR  "u_long *"
#else
#  define INT32_NAM  "u_int"
#  define INT32_PTR  "u_int *"
#endif

typedef struct commandline {
        int   verbose;
        int   cflag;
        int   hflag;
        int   lflag;
        int   sflag;
        int   mflag;
        int   tflag;
        int   keep;
        char *infile;
        char *outfile;
      } commandline;

typedef struct list {
        char        *val;
        struct list *next;
      } list;

typedef int (*SearchFunc) (definition*, char*);

/*
 * Global variables 
 */
#define MAXLINESIZE 1024
extern char  curline[MAXLINESIZE];
extern char *where;
extern int   linenum;
extern commandline cmd;

extern char *infilename;
extern FILE *fout;
extern FILE *fin;
extern list *defined;

void  reinitialize  (void);
void  ptype         (char*, char*, int);
void  pvname        (char*, char*);
int   isvectordef   (char*, relation);
void  error         (char*);
void  crash         (void);
void  record_open   (char*);
void  expected1     (tok_kind);
void  expected2     (tok_kind, tok_kind);
void  expected3     (tok_kind, tok_kind, tok_kind);
char *fixtype       (char *);
char *stringfix     (char *);
int   System        (const char*);
char *findval       (list *, char*, SearchFunc);
void  storeval      (list**, char*);

void  emit          (definition *def);
void  print_datadef (definition *def);
void  write_most    (void);
void  write_rest    (void);
void  write_register(char*);
void  write_programs(char*);
void  write_stubs   (void);

#endif
