#
# Remote Status RPC client/server programs; Borland version
# Implements rstat & smon specifications
#
# Adapted for WatTCP and djgpp2 by G. Vanem <giva@bgnett.no>
# Original copyright (c) SunSoft
#

!include ..\common.mak

RPC_GEN   = ..\rpcgen\rpcgen.exe

CC        = $(HC_CC)
CFLAGS    = $(HC_CFLAGS)

HEADERS   = klm_prot.h mount.h nfs_prot.h nlm_prot.h rex.h rquota.h \
            rnusers.h rquota.h rstat.h sm_inter.h spray.h yppasswd.h yp.h

BINARIES  = rstat.exp smon.exp
GENERATE1 = rstat_cli.c rstat_svc.c rstat_xdr.c
GENERATE2 = smon_cli.c  smon_svc.c  smon_xdr.c


all:    $(HEADERS) $(GENERATE1) $(GENERATE2) $(BINARIES)

rstat.exp: rstat.o32 rstat_cli.o32 rstat_xdr.o32
        $(CC) -e$@ rstat.o32 rstat_cli.o32 rstat_xdr.o32 @&&|
          $(HC_LFLAGS)
|

smon.exp: smon.o32 smon_cli.o32 smon_xdr.o32
        $(CC) -exp @&&|
          smon.o32 smon_cli.o32 smon_xdr.o32
          $(HC_LFLAGS)
|

rstat.c rstat_pr.c: rstat.h

.c.o32:
        $(CC) -c $(CFLAGS) {$*.c }

.x.h:
	$(RPC_GEN) -h -o $*.h $*.x

rstat_cli.c: rstat.x
        $(RPC_GEN) -l -o $*.c rstat.x

rstat_svc.c: rstat.x
        $(RPC_GEN) -s udp -o $*.c rstat.x

rstat_xdr.c: rstat.x
        $(RPC_GEN) -c -o $*.c rstat.x

smon_cli.c: sm_inter.x
        $(RPC_GEN) -l -o $*.c sm_inter.x

smon_svc.c: sm_inter.x
        $(RPC_GEN) -s udp -o $*.c sm_inter.x

smon_xdr.c: sm_inter.x
        $(RPC_GEN) -c -o $*.c sm_inter.x

clean:
        del *.o32
        del $(GENERATE1)
        del $(GENERATE2)
        del $(BINARIES)
        del $(HEADERS)
        del $(BINARIES:.exp=.map)


