/*
 *  Simple program that prints the status of a remote host, using
 *  the 'Status monitor specification'. See sm_inter.x for details.
 */

#include <stdio.h>
#include <sys/param.h>
#include <rpc/rpc.h>
#include <tcp.h>

#include "sm_inter.h"

int main (int argc, char **argv)
{
  struct sm_stat_res *host_stat;
  struct sm_name      monitor;
  char   *host;
  CLIENT *clnt;

  if (argc != 2)
  {
    fprintf (stderr, "usage: %s `host'\n", argv[0]);
    return (1);
  }

  host = argv[1];

  dbug_init();
  rpc_init();
  sock_init();

  /* client handle
   */
  clnt = clnt_create (host, SM_PROG, SM_VERS, "udp");
  if (!clnt)
  {
    clnt_pcreateerror (argv[0]);
    return (1);
  }

  monitor.mon_name = "nfs";
  host_stat = sm_stat_1 (&monitor, clnt);
  if (!host_stat)
  {
    clnt_perror (clnt, argv[0]);
    return (1);
  }

  return (0);
}
