/*
 *  Configuration hook for Waterloo TCP/IP and Sun's XDR/RPC
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "rpc_mac.h"

extern int _watt_is_init;         /* libwatt.a (sock_ini.c) */

extern void ReadRpcProgFile (const char *);     /* getrpc.c */

RPC_CONFIG _rpc_cfg = { NULL, NULL, NULL, NULL,
                        0, IPPORT_TIMESERVER
                      };

static void (*prev_hook) (const char*, const char*);

static void read_rpc_prog (const char *value)
{
  _rpc_cfg.rpc_programs = strdup (value);
  ReadRpcProgFile (_rpc_cfg.rpc_programs);
}

static void rpc_init_hook (const char *name, const char *value)
{
  static struct config_table rpc_cfg_tab[] = {
         { "PROGRAMS",  ARG_FUNC,   (void*)read_rpc_prog           },
         { "ROOTKEY",   ARG_STRDUP, (void*)&_rpc_cfg.rpc_rootkey   },
         { "KEYSTORE",  ARG_STRDUP, (void*)&_rpc_cfg.rpc_keystore  },
         { "MESSENGER", ARG_STRDUP, (void*)&_rpc_cfg.key_messenger },
         { "LOCAL_PM",  ARG_ATOI,   (void*)&_rpc_cfg.pmap_local    },
         { "TIME_PORT", ARG_ATOI,   (void*)&_rpc_cfg.rtime_port    },
         { NULL }
       };

  if (!parse_config_table(rpc_cfg_tab, "RPC.", name, value) && prev_hook)
     (*prev_hook) (name, value);
}

/*
 *  Must be called before sock_init()
 */
void rpc_init (void)
{
  if (_watt_is_init)
  {
    (*_printf) ("init_mib() must be called before sock_init()\r\n");
    exit (-1);
  }
  prev_hook = usr_init;
  usr_init  = rpc_init_hook;
}

